
Ruby - Bug #12291

Struct member accessor is not consistent with hash access when keys are repeated

04/15/2016 04:12 PM - jcole1989 (James Coleman)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.0p0 (2015-12-25 revision

53290) [x86_64-darwin15]

Backport: 2.1: REQUIRED, 2.2: DONE, 2.3: DONE

Description

irb(main):001:0> foo = Struct.new(:a, :a).new("1", "2")

=> #<struct a="1", a="2">

irb(main):002:0> foo.a

=> "2"

irb(main):003:0> foo['a']

=> "1"

irb(main):004:0> foo.members

=> [:a, :a]

irb(main):005:0> foo.to_h

=> {:a=>"2"}

Associated revisions

Revision da2e0721b1ba94e8e786224469fe4bf7550c996a - 04/16/2016 01:00 AM - nobu (Nobuyoshi Nakada)

struct.c: unique members

struct.c (struct_make_members_list, rb_struct_s_def): member

names should be unique. [ruby-core:74971] [Bug #12291]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@54612 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision da2e0721 - 04/16/2016 01:00 AM - nobu (Nobuyoshi Nakada)

struct.c: unique members

struct.c (struct_make_members_list, rb_struct_s_def): member

names should be unique. [ruby-core:74971] [Bug #12291]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@54612 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9dc33b83bb866e0bc0c4d67e32040b31d26e0738 - 04/18/2016 09:12 AM - naruse (Yui NARUSE)

merge revision(s) 54611,54612: [Backport #12291]

    * struct.c (struct_make_members_list): extract making member name

      list from char* va_list, with creating symbols without

      intermediate IDs.

    * struct.c (struct_make_members_list, rb_struct_s_def): member

      names should be unique. [ruby-core:74971] [Bug #12291]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54637 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9dc33b83 - 04/18/2016 09:12 AM - naruse (Yui NARUSE)

merge revision(s) 54611,54612: [Backport #12291]

    * struct.c (struct_make_members_list): extract making member name

      list from char* va_list, with creating symbols without

      intermediate IDs.

    * struct.c (struct_make_members_list, rb_struct_s_def): member

      names should be unique. [ruby-core:74971] [Bug #12291]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54637 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 88efadca4aea13b6c5f3cd4b39c932004d4a23e2 - 04/22/2016 06:59 AM - U.Nakamura 

merge revision(s) 54611,54612: [Backport #12291]

    * struct.c (struct_make_members_list): extract making member name

      list from char* va_list, with creating symbols without

      intermediate IDs.

    * struct.c (struct_make_members_list, rb_struct_s_def): member

      names should be unique. [ruby-core:74971] [Bug #12291]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54685 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 88efadca - 04/22/2016 06:59 AM - U.Nakamura 

merge revision(s) 54611,54612: [Backport #12291]

    * struct.c (struct_make_members_list): extract making member name

      list from char* va_list, with creating symbols without

      intermediate IDs.

    * struct.c (struct_make_members_list, rb_struct_s_def): member

      names should be unique. [ruby-core:74971] [Bug #12291]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54685 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/15/2016 04:13 PM - jcole1989 (James Coleman)

I would expect that foo['a'] and foo.a to return the same value.

#2 - 04/15/2016 04:25 PM - jkrmr (Jake Romer)

Interestingly, I'm seeing the following on ruby 2.0.0p648:

[1] pry(main)> foo = Struct.new(:a, :a).new("1", "2")

=> #<struct  a="1", a="1">

#3 - 04/16/2016 12:57 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED

#4 - 04/16/2016 01:00 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r54612.

struct.c: unique members

struct.c (struct_make_members_list, rb_struct_s_def): member

names should be unique. [ruby-core:74971] [Bug #12291]

#5 - 04/18/2016 09:13 AM - naruse (Yui NARUSE)

- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: DONE

ruby_2_3 r54637 merged revision(s) 54611,54612.

#6 - 04/22/2016 06:59 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: DONE to 2.1: REQUIRED, 2.2: DONE, 2.3: DONE

ruby_2_2 r54685 merged revision(s) 54611,54612.
